image: node:7

stages:
  - prepare
  - build
  - test
  - deploy

install dependencies:
  stage: prepare
  script:
    - npm install
    - npm run fetch-schema
  artifacts:
    paths:
      - node_modules/
      - schema.json
    expire_in: 1 week

build:
  stage: build
  script:
    - npm run build
  artifacts:
    paths:
      - dist/
    expire_in: 1 week

unit tests:
  stage: test
  script:
    - npm run test:unit

integration tests:
  stage: test
  script:
    - npm run test:integration

acceptance tests:
  stage: test
  script:
    - npm run test:acceptance

deploy to dev:
  stage: deploy
  script:
    - npm run deploy
  except:
    - develop
    - master
  variables:
    CI_ENVIRONMENT_URL: http://saas-starter-$CI_BUILD_REF_NAME.surge.sh
  environment:
    name: dev/$CI_BUILD_REF_NAME
    url: http://saas-starter-$CI_BUILD_REF_NAME.surge.sh

deploy to qa:
  stage: deploy
  script:
    - npm run deploy
  only:
    - develop
  variables:
    CI_ENVIRONMENT_URL: http://saas-starter-qa.surge.sh
  environment:
    name: qa
    url: http://saas-starter-qa.surge.sh


deploy to production:
  stage: deploy
  script:
    - npm run deploy
  only:
    - master
  variables:
    CI_ENVIRONMENT_URL: http://saas-starter.surge.sh
  environment:
    name: prod
    url: http://saas-starter.surge.sh
